/***********************************************************************
*  Class Applet
*  The Main Interface class
*  Ehab W. Aziz Rez
***********************************************************************/

import java.util.*;
import java.awt.*;
import java.awt.event.*;
import java.applet.*;

public class Applett extends Applet {


	/** Current xValue */
	private double xValue;
	private double x_low, x_high, y_low, y_high;//the values of the axes boundaries.
	private double divx, labx, divy,laby;//the amount to devide and label axes
	private String expression;

	private final static String newline = "\n";

	/* GUI components */
	private TextField exprField,exprField2, xField;
	private Label expressionEquals,expressionEquals2, forX, result;
	private Button yEquals;

	private GraphArea ga;
	private Label lowx, highx, lowy, highy, dividx, labelx, dividy, labely;
	private Label Y1SlopeAtXEquals, Y2SlopeAtXEquals;
	private TextField xlow, xhigh, ylow, yhigh, dividX, labelX, dividY, labelY;
	private TextField Y1SlopeXValue, Y2SlopeXValue;
	private Button drawY1, drawY2, clearY1, clearY2;
	private Button drawY1Slope,drawY2Slope, clearY1Slope, clearY2Slope;
	private Button drawY1SlopeCurve, drawY2SlopeCurve, clearY1SlopeCurve, clearY2SlopeCurve;

	//panel2
	private Label RootRFrom, RootRTo, RootStep;
	private TextField RRF, RRT,RS;
	private Button FindRoots, defIntegral, showIntegral, clearIntegral;
	Label Max_Min;
	private TextArea RootsTextArea, MaxMin, integralResult;

	//panel 3

    //panel 4
    private Button Diff_Eq, phase_plane, DView, print, save;





public static void main(String args[]) {
		Applett a = new Applett();
		a.init();
		a.start();

		Frame f = new Frame("MAT WIN");
		f.add("Center", a);
		f.setSize(900,700);
		f.addWindowListener(
			new WindowAdapter() {
				public void windowClosing(WindowEvent e) {
					System.exit(0);
				}
			}
		);
//Menue Bar
		MenuBar myMenubar = new MenuBar();
		Menu fileMenu = new Menu("File");
        Menu editMenu = new Menu("Edit");

        MenuItem undo = new MenuItem("Undo");
		editMenu.add(undo);
		editMenu.addSeparator();
		MenuItem cut = new MenuItem("Cut");
		editMenu.add(cut);
		MenuItem copy = new MenuItem("Copy");
		editMenu.add(copy);
		MenuItem paste = new MenuItem("Paste");
		editMenu.add(paste);
		MenuItem clear = new MenuItem("Clear");
		editMenu.add(clear);
		editMenu.addSeparator();
		MenuItem selectAll = new MenuItem("Select All");
        editMenu.add(selectAll);

        myMenubar.add(fileMenu);
        myMenubar.add(editMenu);
        f.setMenuBar(myMenubar);

		f.setVisible(true);
	}


	public void init() {
		xValue = 10.0;
		x_low = -100; x_high = 100; y_low = -100; y_high = 100; //the default values
		divx  =  10;  labx   = 20;  divy = 10  ; laby   = 20 ;
		expression = "100* sin(x/5)* cos(x/50)";
		// add the interface components
		addGUIComponents1();
		}


/**
	 * Creates and adds the necessary GUI components.
	 */
	private void addGUIComponents1() {
		setBackground(Color.white);

		GridBagLayout gridbag = new GridBagLayout();
		GridBagConstraints c = new GridBagConstraints();
		setLayout(gridbag);
		c.fill = GridBagConstraints.BOTH;
		c.weightx = 1.0;

	//Panel1
		Panel panel1 = new Panel(gridbag);
	//the Expresion textfields
		expressionEquals = new Label("Expression Y1 =", Label.LEFT);
		c.gridy=1;
		panel1.add(expressionEquals, c);
		exprField = new TextField(expression,20);//default expression = x*x
		c.gridwidth = GridBagConstraints.REMAINDER;
		panel1.add(exprField, c);

        c.gridy=2;
		expressionEquals2 = new Label("Expression Y2 =", Label.LEFT);
		c.gridwidth = 1;
		panel1.add(expressionEquals2, c);
		exprField2 = new TextField(expression,20);//default expression = x*x
		c.gridwidth = GridBagConstraints.REMAINDER;
		panel1.add(exprField2, c);



	//The graph area
	    c.gridy=3;
		c.insets = new Insets(0, 0, 2, 0);
		c.fill = GridBagConstraints.BOTH; c.weighty=1;
		ga = new GraphArea(x_low,x_high, y_low, y_high);
		ga.setExpression(exprField.getText());
		ga.setaxesDevisionsAndLabels(divx,labx,divy,laby);
		c.gridwidth = GridBagConstraints.REMAINDER;   panel1.add(ga,c);

	/*/the boundary buttons
	    c.weighty = 1; c.weightx=0.5;
	    c.gridy=4;

		lowx  = new Label("Low x", Label.RIGHT);
		c.gridwidth = 1; panel1.add(lowx, c);
		//
		xlow = new TextField("" + x_low,3);
		c.gridwidth = 1; panel1.add(xlow, c);
		//
		highx = new Label("High x", Label.RIGHT);
		c.gridwidth = 1; panel1.add(highx, c);
		//
		xhigh = new TextField("" + x_high,3);
		c.gridwidth = 1; panel1.add(xhigh, c);
		//
		lowy  = new Label("Low y", Label.RIGHT);
		c.gridwidth = 1; panel1.add(lowy, c);
		//
		ylow = new TextField("" + y_low,3);
		c.gridwidth = 1; panel1.add(ylow, c);
		//
		highy = new Label("High y", Label.RIGHT);
		c.gridwidth = GridBagConstraints.RELATIVE;
		panel1.add(highy, c);
		//
		yhigh = new TextField("" + y_high,3);
		c.gridwidth = GridBagConstraints.REMAINDER;
		panel1.add(yhigh,c);

	//X and Y divisions and labeing
	    c.gridy=5;
		dividx  = new Label("Divide X into", Label.RIGHT);
		c.gridwidth = 1; panel1.add(dividx, c);
		//
		dividX = new TextField(""+ divx ,3);
		c.gridwidth = 1; panel1.add(dividX, c);
		//
		labelx = new Label("Label X every", Label.RIGHT);
		c.gridwidth = 1; panel1.add(labelx, c);
		//
		labelX = new TextField("" + labx ,3);
		c.gridwidth = 1; panel1.add(labelX,c);
		//
		dividy  = new Label("Divide Y into", Label.RIGHT);
		c.gridwidth = 1; panel1.add(dividy, c);
		//
		dividY = new TextField("" + divy,3);
		c.gridwidth = 1; panel1.add(dividY, c);
		//
		labely = new Label("Label Y every", Label.RIGHT);
		c.gridwidth = GridBagConstraints.RELATIVE;
		panel1.add(labely, c);
		//
		labelY = new TextField("" + laby ,3);
		c.gridwidth = GridBagConstraints.REMAINDER;;
		panel1.add(labelY,c);

	//Buttons draw, clear
	    c.gridy=6;
		drawY1 = new Button("Draw Y1");
		drawY2 = new Button("Draw Y2");
		clearY1 = new Button("Clear Y1");
		clearY2 = new Button("Clear Y2");
		c.gridwidth = 2; c.weightx = 0.5;
		c.insets = new Insets(0,0,2,30);
		c.fill=GridBagConstraints.HORIZONTAL;
		panel1.add(drawY1, c); panel1.add(drawY2, c);
		panel1.add(clearY1, c); panel1.add(clearY2, c);
		c.insets = new Insets(0,0,2,0);


	//
	    c.gridy=7;
	    Y1SlopeAtXEquals = new Label("For X=", Label.RIGHT);
	    Y1SlopeXValue = new TextField("",3);
	    drawY1Slope = new Button("Draw dY1/dx");
	    Y2SlopeAtXEquals = new Label("For X=", Label.RIGHT);
	    Y2SlopeXValue = new TextField("",3);
	    drawY2Slope = new Button("Draw dY2/dx");
	    clearY1Slope = new Button("Clear line");
	    clearY2Slope = new Button("Clear line");

	    c.gridwidth = 1; c.weightx = 0.5;
	    //c.fill=GridBagConstraints.HORIZONTAL;
	    panel1.add(Y1SlopeAtXEquals,c);
	    panel1.add(Y1SlopeXValue,c);
	    panel1.add(drawY1Slope,c);
	    panel1.add(clearY1Slope,c);
	    panel1.add(Y2SlopeAtXEquals,c);
	    panel1.add(Y2SlopeXValue,c);
	    panel1.add(drawY2Slope,c);
	    c.gridwidth = GridBagConstraints.REMAINDER;
	    panel1.add(clearY2Slope,c);


   //
        c.gridy=8;
	    drawY1SlopeCurve = new Button("Draw Y1'");
	    drawY2SlopeCurve = new Button("Draw Y2'");
	    clearY1SlopeCurve= new Button("Clear Y1'");
	    clearY2SlopeCurve= new Button("Clear Y2'");
	    c.gridwidth = 2;
	    c.gridx=0; panel1.add(drawY1SlopeCurve, c);
	    c.gridx=2; panel1.add(clearY1SlopeCurve, c);
	    c.gridx=4; panel1.add(drawY2SlopeCurve, c);
	    c.gridx=6; c.gridwidth=GridBagConstraints.REMAINDER;
	    panel1.add(clearY2SlopeCurve, c);


		Diff_Eq = new Button("Diff Eq");
		phase_plane = new Button("Phase Plane");
		DView = new Button("3D View");
		print = new Button("Print");
		save = new Button("Save");
        c.gridwidth = 1; c.weightx = 0.5;

		c.ipady = 40; //make it tall
	    c.gridx=0; c.gridy=4;  panel1.add(Diff_Eq, c);
	    c.gridx=1; c.gridy=4;  panel1.add(phase_plane, c);
	    c.gridx=2; c.gridy=4;  panel1.add(DView, c);

	    c.gridx=3; c.gridy=4;  panel1.add(print, c);
	    c.gridx=4; c.gridy=4;  panel1.add(save, c);

	    c.ipady = 0; //return it back
	    */
	//adding panel1

		c.fill=GridBagConstraints.NONE;
		c.gridx=0; c.gridy=0; c.gridwidth =5; c.weighty=0;c.gridheight=1; add(panel1,c);

	//panel2
	    c.fill=GridBagConstraints.HORIZONTAL;

		Panel panel2 = new Panel(gridbag);
		forX = new Label("for X =", Label.LEFT);
		c.gridx=0; c.gridwidth = GridBagConstraints.RELATIVE;
		panel2.add(forX, c);

		xField = new TextField("" + xValue,5);
		c.gridx=1; c.gridy=0;
		c.gridwidth = GridBagConstraints.REMAINDER;
		panel2.add(xField, c);

		yEquals = new Button(" Y = ");
		c.gridx=0; c.gridy=1;
		panel2.add(yEquals, c);

		result = new Label(" ", Label.LEFT);
		c.gridwidth = GridBagConstraints.REMAINDER;
		c.gridy=2; 		panel2.add(result, c);

		RootRFrom = new Label("From ", Label.LEFT);
		RootRTo   = new Label("To ", Label.LEFT);
		RootStep  = new Label("Step", Label.LEFT);
		RRF       = new TextField("", 5);
		RRT       = new TextField("", 5);
		RS       = new TextField("", 5);
		FindRoots = new Button("Roots =");
		c.gridy=3; c.gridwidth = GridBagConstraints.RELATIVE;
		panel2.add(RootRFrom,c);
		c.gridx=1;c.gridwidth=GridBagConstraints.REMAINDER;
		panel2.add(RRF,c);
		c.gridy=4; c.gridwidth = GridBagConstraints.RELATIVE;
		c.gridx=0; panel2.add(RootRTo,c);
		c.gridx=1;c.gridwidth=GridBagConstraints.REMAINDER;
		panel2.add(RRT,c);
		c.gridy=5; c.gridwidth = GridBagConstraints.RELATIVE;
		c.gridx=0; panel2.add(RootStep,c);
		c.gridx=1; c.gridwidth=GridBagConstraints.REMAINDER;
		panel2.add(RS,c);
		c.gridy=6;c.gridx=0; panel2.add(FindRoots,c);

		RootsTextArea = new TextArea("",8,1);
		RootsTextArea.setEditable(false);
		RootsTextArea.setBackground(Color.white);
		c.gridy=7;
		c.gridwidth = GridBagConstraints.REMAINDER;
		c.weightx=1.0; c.weighty=1.0;
		panel2.add(RootsTextArea,c);

		Max_Min =new Label("Max_Min =", Label.CENTER);
		MaxMin = new TextArea("", 5,1);
		c.gridy=8; 	panel2.add(Max_Min, c);
		c.gridy=9;  panel2.add(MaxMin ,c);

		defIntegral = new Button("Def Integral =");
		showIntegral = new Button("Show");
		clearIntegral = new Button("Clear");
		integralResult = new TextArea("",1,1);
		c.gridy=10; c.gridwidth=GridBagConstraints.REMAINDER;
		panel2.add(defIntegral ,c);
		c.gridy=11; panel2.add(integralResult ,c);
		c.gridy=12; c.gridx=0; c.gridwidth=1;
		panel2.add(showIntegral, c);
		c.gridx=1; c.gridwidth=1;
		panel2.add(clearIntegral, c);


	//adding panel2
		c.gridx=5; c.gridy=0; c.gridwidth =1; c.gridheight=1; add(panel2,c);

    //panel3
        c.gridheight =1;
		Panel panel3 = new Panel(gridbag);
    //adding boundary buttons
		lowx  = new Label("Low x =", Label.LEFT);
		c.gridwidth = 1; panel1.add(lowx, c);
        c.gridx=0;c.gridy=0; c.gridwidth = GridBagConstraints.RELATIVE; panel3.add(lowx,c);
		xlow = new TextField("" + x_low,3);
		c.gridx=1;c.gridy=0; c.gridwidth = GridBagConstraints.REMAINDER; panel3.add(xlow,c);
		highx = new Label("High x =", Label.LEFT);
		c.gridx=0;c.gridy=1; c.gridwidth = GridBagConstraints.RELATIVE; panel3.add(highx,c);
		xhigh = new TextField("" + x_high,3);
		c.gridx=1;c.gridy=1; c.gridwidth = GridBagConstraints.REMAINDER; panel3.add(xhigh,c);
		lowy  = new Label("Low y =", Label.LEFT);
		c.gridx=0;c.gridy=2; c.gridwidth = GridBagConstraints.RELATIVE; panel3.add(lowy,c);
		ylow = new TextField("" + y_low,3);
		c.gridx=1;c.gridy=2; c.gridwidth = GridBagConstraints.REMAINDER; panel3.add(ylow,c);
		highy = new Label("High y =", Label.LEFT);
		c.gridx=0;c.gridy=3; c.gridwidth = GridBagConstraints.RELATIVE; panel3.add(highy,c);
		yhigh = new TextField("" + y_high,3);
		c.gridx=1;c.gridy=3; c.gridwidth = GridBagConstraints.REMAINDER; panel3.add(yhigh,c);

	//X and Y divisions and labeing
		dividx  = new Label("Divide X into", Label.LEFT);
		c.gridx=0;c.gridy=4; c.gridwidth = GridBagConstraints.RELATIVE; panel3.add(dividx,c);
		dividX = new TextField(""+ divx ,3);
		c.gridx=1;c.gridy=4; c.gridwidth = GridBagConstraints.REMAINDER; panel3.add(dividX,c);
		labelx = new Label("Label X every", Label.LEFT);
		c.gridx=0;c.gridy=5; c.gridwidth = GridBagConstraints.RELATIVE; panel3.add(labelx,c);
		labelX = new TextField("" + labx ,3);
		c.gridx=1;c.gridy=5; c.gridwidth = GridBagConstraints.REMAINDER; panel3.add(labelX,c);
		dividy  = new Label("Divide Y into", Label.LEFT);
		c.gridx=0;c.gridy=6; c.gridwidth = GridBagConstraints.RELATIVE; panel3.add(dividy,c);
		dividY = new TextField("" + divy,3);
		c.gridx=1;c.gridy=6; c.gridwidth = GridBagConstraints.REMAINDER; panel3.add(dividY,c);
		labely = new Label("Label Y every", Label.LEFT);
		c.gridx=0;c.gridy=7; c.gridwidth = GridBagConstraints.RELATIVE; panel3.add(labely,c);
		labelY = new TextField("" + laby ,3);
		c.gridx=1;c.gridy=7; c.gridwidth = GridBagConstraints.REMAINDER; panel3.add(labelY,c);

	//Buttons draw, clear
		drawY1 = new Button("Draw Y1");
		clearY1 = new Button("Clear Y1");
		c.gridx=0;c.gridy=8; c.gridwidth = GridBagConstraints.RELATIVE; panel3.add(drawY1,c);
		c.gridx=1;c.gridy=8; c.gridwidth = GridBagConstraints.REMAINDER; panel3.add(clearY1,c);
		drawY2 = new Button("Draw Y2");
		clearY2 = new Button("Clear Y2");
		c.gridx=0;c.gridy=9; c.gridwidth = GridBagConstraints.RELATIVE; panel3.add(drawY2,c);
		c.gridx=1;c.gridy=9; c.gridwidth = GridBagConstraints.REMAINDER; panel3.add(clearY2,c);

	//buttons for drawing and clearing the tangent lines
	    Y1SlopeAtXEquals = new Label("For X=", Label.LEFT);
	    Y1SlopeXValue = new TextField("",3);
	    drawY1Slope = new Button("Draw Y1 Tangent Line");
	    Y2SlopeAtXEquals = new Label("For X=", Label.LEFT);
	    Y2SlopeXValue = new TextField("",3);
	    drawY2Slope = new Button("Draw Y2Tangent Line");
	    clearY1Slope = new Button("Clear line");
	    clearY2Slope = new Button("Clear line");
        c.gridx=0;c.gridy=10; c.gridwidth = GridBagConstraints.RELATIVE; panel3.add(Y1SlopeAtXEquals,c);
	    c.gridx=1;c.gridy=10; c.gridwidth = GridBagConstraints.REMAINDER; panel3.add(Y1SlopeXValue,c);
	    c.gridx=0;c.gridy=11; c.gridwidth = GridBagConstraints.REMAINDER; panel3.add(drawY1Slope,c);
	    c.gridx=0;c.gridy=12; c.gridwidth = GridBagConstraints.REMAINDER; panel3.add(clearY1Slope,c);
        c.gridx=0;c.gridy=13; c.gridwidth = GridBagConstraints.RELATIVE; panel3.add(Y2SlopeAtXEquals,c);
	    c.gridx=1;c.gridy=13; c.gridwidth = GridBagConstraints.REMAINDER; panel3.add(Y2SlopeXValue,c);
	    c.gridx=0;c.gridy=14; c.gridwidth = GridBagConstraints.REMAINDER; panel3.add(drawY2Slope,c);
	    c.gridx=0;c.gridy=15; c.gridwidth = GridBagConstraints.REMAINDER; panel3.add(clearY2Slope,c);

   // Buttons for drawing slope curves
	    drawY1SlopeCurve = new Button("Draw Y1' Curve");
	    drawY2SlopeCurve = new Button("Draw Y2' Curve");
	    clearY1SlopeCurve= new Button("Clear Y1'");
	    clearY2SlopeCurve= new Button("Clear Y2'");
	    c.gridx=0;
	    c.gridy=16; c.gridwidth = GridBagConstraints.REMAINDER; panel3.add(drawY1SlopeCurve,c);

	    c.gridy=17; c.gridwidth = GridBagConstraints.REMAINDER; panel3.add(clearY1SlopeCurve,c);

	    c.gridy=18; c.gridwidth = GridBagConstraints.REMAINDER; panel3.add(drawY2SlopeCurve,c);

	    c.gridy=19; c.gridwidth = GridBagConstraints.REMAINDER; panel3.add(clearY2SlopeCurve,c);


	//adding panel3
	    c.fill=GridBagConstraints.NONE;
		c.gridx=6; c.gridy=0; c.gridwidth =1;c.gridheight=1; add(panel3,c);

    //panel4
        Panel panel4 = new Panel(gridbag);

		Diff_Eq = new Button("Diff Eq");
		phase_plane = new Button("Phase Plane");
		DView = new Button("3D View");
		print = new Button("Print");
		save = new Button("Save");
        c.gridwidth = 1; c.weightx = 0.5;

		//c.ipady = 40; //make it tall
	    c.gridx=0; c.gridy=1;  panel4.add(Diff_Eq, c);
	    c.gridx=1; c.gridy=1;  panel4.add(phase_plane, c);
	    c.gridx=2; c.gridy=1;  panel4.add(DView, c);

	    c.gridx=3; c.gridy=1;  panel4.add(print, c);
	    c.gridx=4; c.gridy=1;  panel4.add(save, c);

	    c.ipady = 0; //return it back
    //adding panel4
        c.fill=GridBagConstraints.BOTH;
        c.gridx=0; c.gridy=1; c.gridwidth =5; add(panel4,c);


/** Adding Listeners     */
	//when a new expression is iserted into expresion field
		xField.addTextListener(
							new TextListener() {
								public void textValueChanged(TextEvent evt) {
									xFieldTextValueChanged();
								}
							}
		);

	//when y= button pressed
		yEquals.addActionListener(
					         new ActionListener(){
								 public void actionPerformed(ActionEvent evt) {
									 exprFieldTextValueChanged();
							     }
							 }
		);

	//when draw buttons is pressed
		drawY1.addActionListener(
							         new ActionListener(){
										 public void actionPerformed(ActionEvent evt) {
											 drawY1ButtonPressed();
									     }
									 }
		);
		drawY2.addActionListener(
							         new ActionListener(){
										 public void actionPerformed(ActionEvent evt) {
											 drawY2ButtonPressed();
									     }
									 }
		);
		clearY1.addActionListener(
							         new ActionListener(){
										 public void actionPerformed(ActionEvent evt) {
											 clearY1ButtonPressed();
									     }
									 }
        );

		clearY2.addActionListener(
							         new ActionListener(){
										 public void actionPerformed(ActionEvent evt) {
											 clearY2ButtonPressed();
									     }
									 }
	    );
	    drawY1Slope.addActionListener(
										new ActionListener(){
											public void actionPerformed(ActionEvent evt) {
												drawY1SlopePressed();
											}
										}
		);
        clearY1Slope.addActionListener(
										new ActionListener(){
											public void actionPerformed(ActionEvent evt) {
												clearY1SlopePressed();
											}
										}
		);


		drawY1SlopeCurve.addActionListener(
										new ActionListener(){
											public void actionPerformed(ActionEvent evt) {
												drawY1SlopeCurvePressed();
											}
										}
		);
		clearY1SlopeCurve.addActionListener(
										new ActionListener(){
											public void actionPerformed(ActionEvent evt) {
												clearY1SlopeCurvePressed();
											}
										}
		);

		//panel2
		FindRoots.addActionListener(
										new ActionListener(){
											public void actionPerformed(ActionEvent evt) {
												FindRootsPressed();
											}
										}
		);

		showIntegral.addActionListener(
			                            new ActionListener(){
											public void actionPerformed(ActionEvent evt) {
												showIntegralPressed();
											}
										}
       );
		clearIntegral.addActionListener(
										 new ActionListener(){
											 public void actionPerformed(ActionEvent evt) {
												 clearIntegralPressed();
											 }
										 }
		);

		defIntegral.addActionListener(
										 new ActionListener(){
											 public void actionPerformed(ActionEvent evt) {
												 defIntegralPressed();
											 }
										 }
		);

        Diff_Eq.addActionListener(
			                      new ActionListener(){
									  public void actionPerformed(ActionEvent evt) {
										  Diff_EqPressed();
									  }
								  }
		);

        phase_plane.addActionListener(
			                      new ActionListener(){
									  public void actionPerformed(ActionEvent evt) {
										  phase_planePressed();
									  }
								  }
		);

}//addGUICmponents()

/**
		* Evaluate the current expression in the exprField.
		* this method is called every time the expression or x is changed
		*/
		private double evaluateExpression() {
		Equation eq = new Equation(exprField.getText());
		double x = Double.valueOf(xField.getText()).doubleValue();
		double res = eq.Evaluate("x", x);
		return res;
		}

        private double evaluateExpression(double x)
        {
			Equation eq = new Equation(exprField.getText());
            double res = eq.Evaluate("x", x);
            return res;
        }

		private double evaluateIntegration(double from, double to, double step)
		{
			double value =0.0; //integration value
			double val1 = evaluateExpression(from);
			double currentx= from; //current x value
			for(double k=from+step; k<=to; k+=step)
			{
				currentx = k;
				double val2 = evaluateExpression(k);
				double tobeadded =(0.5)*(val1+val2)*(step);
				value+=tobeadded;
				val1=val2;
			}
			if (currentx<to)
			{
				double val2 = evaluateExpression(to);
				double tobeadded =(0.5)*(val1+val2)*(step);
				value+=tobeadded;
			}

			return value;

		}

        private void actionPerformed(){updateResult();}
		private void exprFieldTextValueChanged() {

		updateResult();
		}

		private void xFieldTextValueChanged() {

		try {
		     xValue = Double.valueOf(xField.getText()).doubleValue();
		    } catch (NumberFormatException e) {

					xValue = 0;
		    }



				updateResult();
		}

		private void drawY1ButtonPressed(){
			ga.setExpression(exprField.getText());

			double xl = Double.valueOf(xlow.getText()).doubleValue();
			double xh = Double.valueOf(xhigh.getText()).doubleValue();
			double yl = Double.valueOf(ylow.getText()).doubleValue();
			double yh = Double.valueOf(yhigh.getText()).doubleValue();
			ga.setBoundaries(xl,xh,yl,yh);


			double xd = Double.valueOf(dividX.getText()).doubleValue();
			double xlab = Double.valueOf(labelX.getText()).doubleValue();
			double yd = Double.valueOf(dividY.getText()).doubleValue();
			double ylab = Double.valueOf(labelY.getText()).doubleValue();
			ga.setaxesDevisionsAndLabels(xd,xlab,yd,ylab);

			ga.setFunctionDrawer(true);

			ga.repaint();
			//ga.setFunctionDrawer(false);
		}

		private void drawY2ButtonPressed(){
			ga.setExpression2(exprField2.getText());

			double xl = Double.valueOf(xlow.getText()).doubleValue();
			double xh = Double.valueOf(xhigh.getText()).doubleValue();
			double yl = Double.valueOf(ylow.getText()).doubleValue();
			double yh = Double.valueOf(yhigh.getText()).doubleValue();
			ga.setBoundaries(xl,xh,yl,yh);


			double xd = Double.valueOf(dividX.getText()).doubleValue();
			double xlab = Double.valueOf(labelX.getText()).doubleValue();
			double yd = Double.valueOf(dividY.getText()).doubleValue();
			double ylab = Double.valueOf(labelY.getText()).doubleValue();
			ga.setaxesDevisionsAndLabels(xd,xlab,yd,ylab);

			ga.setFunction2Drawer(true);

			ga.repaint();
			//ga.setFunction2Drawer(false);
		}

		private void clearY1ButtonPressed(){
			ga.setFunctionDrawer(false);
			ga.repaint();
		}
		private void clearY2ButtonPressed(){
			ga.setFunction2Drawer(false);
			ga.repaint();
		}
		private void drawY1SlopePressed(){
			ga.setY1Slope(true);

			ga.setY1Slope_x(Double.valueOf(Y1SlopeXValue.getText()).doubleValue());


			ga.repaint();
		}
		private void clearY1SlopePressed()
		{
			ga.setY1Slope(false);
			ga.repaint();
		}
		private void drawY1SlopeCurvePressed()
		{
			ga.setY1SlopeCurve(true);
			ga.repaint();
		}
		private void clearY1SlopeCurvePressed()
		{
			ga.setY1SlopeCurve(false);
			ga.repaint();
		}
        private void clearY2SlopeCurvePressed()
		{
			ga.setY2SlopeCurve(false);
			ga.repaint();
		}
		private void FindRootsPressed()
		{
			double xfrom = Double.valueOf(RRF.getText()).doubleValue();
			double xto = Double.valueOf(RRT.getText()).doubleValue();
			double step = Double.valueOf(RS.getText()).doubleValue();


			expression = exprField.getText();
			RootsTextArea.setText("");
			RootFinder rf = new RootFinder(expression, 0.0001);
			Vector<String> v1=rf.findAllRoots(xfrom,xto,step );

			for(int j=0; j<v1.size();j++)
			RootsTextArea.append(v1.get(j)+ newline);

			MaxMin.setText("");
			MaxMinFinder mf = new MaxMinFinder(expression);
			Vector<String> v2=mf.findMaxMin(xfrom, xto, step, 0.0001);
			for(int h=0; h<v2.size();h++)
			MaxMin.append(v2.get(h)+newline);

		}

		private void defIntegralPressed()
		{
			double xfrom = Double.valueOf(RRF.getText()).doubleValue();
			double xto = Double.valueOf(RRT.getText()).doubleValue();
			double step = Double.valueOf(RS.getText()).doubleValue();

			double defInt = evaluateIntegration(xfrom, xto, step);
			String stt = Double.toString(defInt);
			integralResult.setText(stt);
		}

		private void showIntegralPressed()
		{
			double xfrom = Double.valueOf(RRF.getText()).doubleValue();
			double xto = Double.valueOf(RRT.getText()).doubleValue();
			double step = Double.valueOf(RS.getText()).doubleValue();
			expression = exprField.getText();
			ga.setFromToStep(xfrom, xto, step);
			ga.setShowInteg(true);
			ga.repaint();
		}
		private void clearIntegralPressed()
		{
			ga.setShowInteg(false);
			ga.repaint();
		}
		private void Diff_EqPressed()
		{
			Applett2 aa = new Applett2();
 		    aa.init(); 		aa.start();
            final Frame f = new Frame("DIFF EQ");
            f.add("Center", aa);
            f.setSize(650,575);
            f.addWindowListener(
				new WindowAdapter() {
					public void windowClosing(WindowEvent e) {
						f.dispose();
					}
				}
			);
		    f.setVisible(true);
	    }

	    private void phase_planePressed()
	    {
			PhasePlaneApplett aa = new PhasePlaneApplett();
 		    aa.init(); 		aa.start();
            final Frame f = new Frame("DIFF EQ, Phase Plane");
            f.add("Center", aa);
            f.setSize(650,580);
            f.addWindowListener(
				new WindowAdapter() {
					public void windowClosing(WindowEvent e) {
						f.dispose();
					}
				}
			);
		    f.setVisible(true);
		}

        private void updateResult() {
			double res;
			// Get the value
			res = evaluateExpression();
			result.setText("  " + Double.toString(res));
		}

}//class


















