/***********************************************************************************
*
*  Class Equation
*  equation is passed as constructor argument and the value
*  is evaluated by Evaluate()
*
*  9-16-06
*  Ehab W. Aziz Rezk
*
************************************************************************************/


import java.util.*;



public class Equation
{
  private String equation_String;
  private Vector<String>equation_Tokens; //contains the elements of equation_String

  static int convert(String s)
  // required for function Evaluate. it converts the operator to an int representation
  { if( s.equalsIgnoreCase(new String(")")))     return  0;
    if( s.equalsIgnoreCase(new String("+")))     return  1;
    if( s.equalsIgnoreCase(new String("-")))     return  2;
    if( s.equalsIgnoreCase(new String("*")))     return  3;
    if( s.equalsIgnoreCase(new String("/")))     return  4;
    if( s.equalsIgnoreCase(new String("^")))     return  5;
    if( s.equalsIgnoreCase(new String("sin")))   return  6;
    if( s.equalsIgnoreCase(new String("cos")))   return  7;
    if( s.equalsIgnoreCase(new String("tan")))   return  8;
    if( s.equalsIgnoreCase(new String("ln")))    return  9;  //log base e
    if( s.equalsIgnoreCase(new String("exp")))   return  10;
    if( s.equalsIgnoreCase(new String("asin")))  return  11;
	if( s.equalsIgnoreCase(new String("acos")))  return  12;
	if( s.equalsIgnoreCase(new String("atan")))  return  13;
    if( s.equalsIgnoreCase(new String("sqrt")))  return  14;
    if( s.equalsIgnoreCase(new String("sec")))   return  15;
    if( s.equalsIgnoreCase(new String("csc")))   return  16;
    if( s.equalsIgnoreCase(new String("cot")))   return  17;
    if( s.equalsIgnoreCase(new String("log")))   return  18; //base 10
    if( s.equalsIgnoreCase(new String("(")))     return  20;
    else                                         return  -1;
  }//convert

  static  boolean isOperator(String s)
  //return true if s is an operator
  {
    if     ( s.equalsIgnoreCase(new String(")"))) return true;
    else if( s.equalsIgnoreCase(new String("+"))) return true;
    else if( s.equalsIgnoreCase(new String("-"))) return true;
    else if( s.equalsIgnoreCase(new String("*"))) return true;
    else if( s.equalsIgnoreCase(new String("/"))) return true;
    else if( s.equalsIgnoreCase(new String("^"))) return true;
    else if( s.equalsIgnoreCase(new String("("))) return true;
    else                                          return false;
  }//isOperator

  static boolean isOperator2(String s)
    //return true for sin, cos, tan, cot, sec.
    {
      if      (s.equalsIgnoreCase(new String("sin")))return  true;
      else if (s.equalsIgnoreCase(new String("cos")))return  true;
      else if (s.equalsIgnoreCase(new String("tan")))return  true;
      else if (s.equalsIgnoreCase(new String("cot")))return  true;
      else if (s.equalsIgnoreCase(new String("sec")))return  true;
      else if (s.equalsIgnoreCase(new String("csc")))return  true;
      else if (s.equalsIgnoreCase(new String("log")))return  true;
      else if (s.equalsIgnoreCase(new String("exp")))return  true;
      else                                           return false;
    }//isOprator2()

  static boolean isOperator3(String s)
      //return true for ln
      {
        if      (s.equalsIgnoreCase(new String("ln"))) return  true;
        else                                           return false;
      }//isOprator3()

  static boolean isOperator4(String s)
      //return true for sqrt, asin, acos,  atan
      {
        if      (s.equalsIgnoreCase(new String("asin")))return  true;
        else if (s.equalsIgnoreCase(new String("acos")))return  true;
        else if (s.equalsIgnoreCase(new String("atan")))return  true;
        else if (s.equalsIgnoreCase(new String("sqrt")))return  true;
        else                                            return false;
  }//isOprator4()

  static boolean isNumber(char s)
  //return true for numbers
  {
    boolean returnValue=true;

    { if (s !='.' && s !='0' && s !='1' && s !='2' && s !='3' && s !='4' && s !='5' &&
	          s !='6' && s !='7' && s !='8' && s !='9'&& s !='x'&& s !='X' )
	        returnValue = false;
    }
    return returnValue;
  }//isnumber()

  static void evaluate(Stack<Double> operand, Stack<String> oprator)
  {
    double operand1, operand2; int op; double result=0.0;

    operand2 = (operand.peek()).doubleValue(); operand.pop();
    operand1 = (operand.peek()).doubleValue(); operand.pop();
    op = (convert(oprator.peek())); oprator.pop();
    switch (op)
    {
      case 1: result = operand1 + operand2;
              break;
      case 2: result = operand1 - operand2;
              break;
      case 3: result = operand1 * operand2;
              break;
      case 4: result = operand1 / operand2;
              break;
      case 5: result = (Math.pow(operand1, operand2));
              break;
      default:break;

    }

    operand.push(result);
  }//evaluate()

  static void evaluate2(Stack<Double> operand, Stack<String> oprator)
  {
      double operand1; int op; double result=0.0;

      operand1 = (operand.peek()).doubleValue(); operand.pop();
      op = (convert(oprator.peek())); oprator.pop();
      switch (op)
      {
        case 6: result = (Math.sin(operand1) );
                 break;
        case 7: result = (Math.cos(operand1) );
                 break;
        case 8: result = (Math.tan(operand1) );
                 break;
        case 9: result = (Math.log(operand1) );
                 break;
        case 10: result = (Math.exp(operand1) );
                 break;
        case 11: result = (Math.asin(operand1) );
		         break;
		case 12: result = Math.acos(operand1) ;
		         break;
        case 13: result = Math.atan(operand1);
		         break;
		case 14: result = Math.sqrt(operand1) ;
                 break;
		case 15: result = 1/(Math.cos(operand1) );
		         break;
        case 16: result = 1/(Math.sin(operand1));
		         break;
		case 17: result = 1/(Math.tan(operand1) ) ;
                 break;
		case 18: result = (Math.log(operand1) )/(Math.log(10) ) ;
                 break;//case 18 returns the log to the base 10
        default: break;

      }

      operand.push(result);
  }//evaluate2()

  static boolean isLetter(char s)
  {
	  //return true if s is letter
	   boolean returnValue=true;


	   { if (s !='a' && s !='A' && s !='b' && s !='B' && s !='c' && s !='C' && s !='d' &&
	  	     s !='D' && s !='e' && s !='E' && s !='f' && s !='F' && s !='g' && s !='G' &&
	  	     s !='h' && s !='H' && s !='i' && s !='I' && s !='j' && s !='J' && s !='k' &&
	  	     s !='K' && s !='l' && s !='L' && s !='m' && s !='M' && s !='n' && s !='N' &&
	  	     s !='o' && s !='O' && s !='p' && s !='P' && s !='q' && s !='Q' && s !='r' &&
	  	     s !='R' && s !='s' && s !='S' && s !='t' && s !='T' && s !='u' && s !='U' &&
	  	     s !='v' && s !='V' && s !='w' && s !='W' && s !='x' && s !='X' && s !='y' &&
	  	     s !='Y' && s !='z' && s !='Z')
	  	        returnValue = false;
	   }
       return returnValue;
  }

  /**
   The folowing function (vectorAdjust) is added to adjust the vector comming
   from class String to vector tokenizer
   it adjust equation like -sin.., -(...),... to (-1)*sin..,...
   this will enable the Evaluate function in the Equation class
   to correctly parse the expression to evaluate it
   It also replace e and pi by their mathematical values
   */
  static Vector<String> vectorAdjust(Vector<String> vec)
  {
	  Vector<String> v =new Vector<String>();
	  v.add("(");  v.add("-1"); v.add(")"); v.add("*");
	  if(vec.get(0).equals("-"))
	  {
		  //if the leading character is a negative sine"-", replace it with "(-1)*"
		  vec.removeElementAt(0);  vec.addAll(0,v);

	  }
	  else{
		  for(int i=0;i<vec.size()-2; i++)
	      {
			  if(vec.get(i).equals("(")&&vec.get(i+1).equals("-"))
			  {
				  //if ( is followed by - change - to "(0-1)*"
				  vec.removeElementAt(i+1);  vec.addAll(i+1,v);
			  }

			  else{}
	      }

	  }//else
	  return vec;
  }

  public Equation(String str)
  {//

    equation_String = (str.trim()).concat("@");//adding @to the end

    StringToVectorTokenizer stv = new StringToVectorTokenizer(str);
    Vector<String> v= vectorAdjust(stv.tokenizeToVector());//see function vetorAdjust
    for(int i=0; i<v.size(); i++)
    {
		double e = Math.E; double pi =Math.PI;

		if(v.get(i).equalsIgnoreCase("e"))
		{
			String s = Double.toString(e);
			v.set(i, s);
		}
		else if(v.get(i).equalsIgnoreCase("-e"))
		{
			String s = "-".concat(Double.toString(e));
			v.set(i, s);
		}
		else if(v.get(i).equalsIgnoreCase("pi"))
		{
			String s = Double.toString(pi);
			v.set(i, s);
		}
		else if(v.get(i).equalsIgnoreCase("-pi"))
		{
			String s = "-".concat(Double.toString(pi));
			v.set(i, s);
		}
		else{}
	}
    equation_Tokens = v;


  }//Equation(String)


  public double Evaluate(String x, double d)//evaluate after substituting x with d
  {//return the double value of the euation_string
    Vector <String> temp = equation_Tokens; //a copyof the equation vector
    for(int i=0; i<temp.size(); i++) //replacing x with d
    {if((temp.elementAt(i)).equalsIgnoreCase(x)) temp.setElementAt( Double.toString(d),i);
     if((temp.elementAt(i)).equalsIgnoreCase("-"+x)&&d>0)
        temp.setElementAt( ("-"+Double.toString(d)),i);
     if((temp.elementAt(i)).equalsIgnoreCase("-"+x)&&d==0)
        temp.setElementAt( Double.toString(0),i);
     if((temp.elementAt(i)).equalsIgnoreCase("-"+x)&&d<0)
        temp.setElementAt( Double.toString(Math.abs(d)),i);
    }

    Stack<Double> operand = new Stack<Double>();
    Stack<String> oprator = new Stack<String>();
    int op;                    //int equivallent of operator returned from convert
    String token = temp.firstElement() ;

    for(int i=0; i< temp.size(); i++)
    {
      token = temp.elementAt(i);
      if(isOperator(token)||isOperator2(token)||isOperator3(token)||isOperator4(token))
      {
        if (token.equalsIgnoreCase( ")"))
        {
          while(!(oprator.peek()).equalsIgnoreCase("(") )
             {if(isOperator(oprator.peek()))evaluate(operand, oprator);
              else{evaluate2(operand, oprator);}
		     }
          oprator.pop();                        //pop"("
        } else
        { op = convert(token);
          while(!oprator.empty()&&!(oprator.peek()).equalsIgnoreCase("(") && op<=convert(oprator.peek()))
            {if(isOperator(oprator.peek()))evaluate(operand, oprator);
             else{evaluate2(operand, oprator);}
		    }
           oprator.push(token);
        }//else
      }//if

      else  if(isNumber(token.charAt(0)) ) //token is a number
       operand.push(Double.valueOf(token).doubleValue());



      else{operand.push(Double.valueOf(token).doubleValue());}

    }//for

    while (!oprator.empty())
     {if(isOperator(oprator.peek()))evaluate(operand, oprator);
      else{evaluate2(operand, oprator);}
     }

    return operand.peek();

  }//Evaluate

  public double Evaluate(double d1, double d2)
   //evaluate after substituting two variables x(first), y(seond) of the equation with d1 qand d2
  {
    Vector <String> temp = equation_Tokens; //a copyof the equation vector
    /////////
    for(int i=0; i<temp.size(); i++) //replacing x with d
	{if((temp.elementAt(i)).equalsIgnoreCase("x")) temp.setElementAt( Double.toString(d1),i);
     if((temp.elementAt(i)).equalsIgnoreCase("-x")&&d1>0)
        temp.setElementAt( ("-"+Double.toString(d1)),i);
     if((temp.elementAt(i)).equalsIgnoreCase("-x")&&d1==0)
        temp.setElementAt( Double.toString(0),i);
     if((temp.elementAt(i)).equalsIgnoreCase("-x")&&d1<0)
        temp.setElementAt( Double.toString(Math.abs(d1)),i);

     if((temp.elementAt(i)).equalsIgnoreCase("y")) temp.setElementAt( Double.toString(d2),i);
     if((temp.elementAt(i)).equalsIgnoreCase("-y")&&d2>0)
        temp.setElementAt( ("-"+Double.toString(d2)),i);
     if((temp.elementAt(i)).equalsIgnoreCase("-y")&&d2==0)
     	temp.setElementAt( Double.toString(0),i);
     if((temp.elementAt(i)).equalsIgnoreCase("-y")&&d2<0)
     	temp.setElementAt( Double.toString(Math.abs(d2)),i);

    }

    Stack<Double> operand = new Stack<Double>();
    Stack<String> oprator = new Stack<String>();
    int op;                    //int equivallent of operator returned from convert
    String token = temp.firstElement() ;

    for(int i=0; i< temp.size(); i++)
    {
      token = temp.elementAt(i);
      if(isOperator(token)||isOperator2(token)||isOperator3(token)||isOperator4(token))
      {
        if (token.equalsIgnoreCase( ")"))
        {
          while(!(oprator.peek()).equalsIgnoreCase("(") )
             {if(isOperator(oprator.peek()))evaluate(operand, oprator);
              else{evaluate2(operand, oprator);}
		     }
          oprator.pop();                        //pop"("
        } else
        { op = convert(token);
          while(!oprator.empty()&&!(oprator.peek()).equalsIgnoreCase("(") && op<=convert(oprator.peek()))
            {if(isOperator(oprator.peek()))evaluate(operand, oprator);
             else{evaluate2(operand, oprator);}
		    }
           oprator.push(token);
        }//else
      }//if

      else  if(isNumber(token.charAt(0)) ) //token is a number
       operand.push(Double.valueOf(token).doubleValue());



      else{operand.push(Double.valueOf(token).doubleValue());}

    }//for

    while (!oprator.empty())
     {if(isOperator(oprator.peek()))evaluate(operand, oprator);
      else{evaluate2(operand, oprator);}
     }

    return operand.peek();

  }//Evaluate(double, double)

  public void print_equation_Tokens()
  {
    System.out.print("\n");
    for(int i=0; i<equation_Tokens.size()-1; i++)
    System.out.print(equation_Tokens.get(i) +", " );
    System.out.print(equation_Tokens.lastElement() +"\n");
  }


  public String get_equation_String()
  {
    return equation_String;
  }


  public Vector<String>  get_equation_Tokens()
  {
   return equation_Tokens;
  }





  public static void main(String[ ] args)
  {
	Scanner sc = new Scanner(System.in);
	System.out.print("write down the Equation ");
	String equation =sc.nextLine();

    Equation eq =new Equation(equation);
    eq.print_equation_Tokens();

	Scanner sc2 = new Scanner(System.in);
	System.out.println("for x = ");
	String input =sc2.nextLine();
	double value1 = Double.valueOf(input.trim()).doubleValue();

	Scanner sc3 = new Scanner(System.in);
	System.out.println("and y = ");
	String input2 =sc3.nextLine();
	double value2 = Double.valueOf(input2.trim()).doubleValue();



    //String x="x";
    System.out.println("\n result = " +eq.Evaluate(value1, value2));


  }


}//Equation class
