import java.awt.*;
import java.awt.geom.*;

public class GraphArea extends Canvas {

  Dimension dimensions; //the canvas dimensions

  private double xlow, xhigh, ylow, yhigh;
  private double DevideX, LabelX, DevideY, LabelY;
  private double y1Slope_x;
  private String expression, expression2;
  private double xScale, yScale;

  private double from, to, step;

  boolean functionDrawer, function2Drawer;//flags to determine which function to draw
  boolean y1Slope; //for drawing the tangent to Y1 at x=...
  boolean y1SlopeCurve, y2SlopeCurve; //for drawing the y1 slope curve
  boolean showInteg;// to show integration

  public GraphArea(double x_low, double x_high, double y_low, double y_high) {

      super();  // call Frame ctor, telling what to label the frame
      dimensions = getPreferredSize(); //=400,400 in this case

      functionDrawer=false;    function2Drawer=false;
      y1Slope = false; y1SlopeCurve=false;
      showInteg = false;

      xlow = x_low; xhigh = x_high; ylow = y_low; yhigh = y_high;
      DevideX = 1; LabelX = 1; DevideY = .1; LabelY = .5;
      y1Slope_x = 0.0;
      expression = "";  expression2="";
      xScale = 1.0; yScale = 1.0;
      from =0; to=0; step=0;

    }

  public void setExpression(String s)
  {
	  expression = s;
  }

  public void setExpression2(String s)
  {
  	  expression2 = s;
  }
  public void setY1Slope_x(double x)//at x we will drw the slope
  {
	  y1Slope_x= x;
  }
  public void setFunctionDrawer(boolean b)
  {
	  functionDrawer=b;
  }
  public void setFunction2Drawer(boolean b)
  {
	  function2Drawer=b;
  }
  public void setY1Slope(boolean b)
  {
	  y1Slope = b;
  }
  public void setY1SlopeCurve(boolean b)
  {
	  y1SlopeCurve=b;
  }
  public void setY2SlopeCurve(boolean b)
  {
	  y2SlopeCurve = b;
  }

  public void setBoundaries(double x_low, double x_high, double y_low, double y_high)
  {
	  xlow = x_low;
	  xhigh = x_high;
	  ylow = y_low;
	  yhigh = y_high;

  }

  public void setaxesDevisionsAndLabels(double dx,double lx,double dy,double ly)
  {
	  DevideX = dx; LabelX = lx; DevideY=dy; LabelY =ly;
  }

  public void setScales(double xsc, double ysc)
  {
	  xScale = xsc; yScale = ysc;
  }

  public void setFromToStep(double a, double b, double c)
  {
	  from = a; to=b; step=c;
  }
  public void setShowInteg(boolean b)
  {
	  showInteg=b;
  }

  public double plottableX(double newx)
  {
	//be aware that the number of units that the origin
	//moves along x axis equals 0-(xlow)

	  double nXUnitsTranslated = 0-xlow; //translation
	  //calculating the xscale.
	  xScale = (xhigh-xlow)/dimensions.width;

	  double x = (newx + nXUnitsTranslated)/xScale;

	  return x;
  }

  public double plottableY(double newy)
  {
	  //
	  double nYUnitsTranslated = 0 +(yhigh);
	  //calculating the Y_Scale
	  yScale = (yhigh-ylow)/dimensions.height;
	  double y = (nYUnitsTranslated - newy)/yScale;
	  return y;
  }

  static double xLowBoundFinder(double x)
  {// find the lowest x boundary to be labled
      boolean state = true; int i=0;
      double y = Math.floor(x);
  	  while(state)
  	  { if(Math.abs(y)<10) state = false;
  	    else{
			y = Math.floor(y/10); i++;

		}
	  }
	  return y*(10^i);
  }
  public void paintAxes(Graphics2D g)
  {
	  //double xOrigin, yOrigin;
	  Graphics2D g2d = (Graphics2D) g;
	  g2d.setColor(Color.white);
  //y-axis
	  g2d.draw(new Line2D.Double(plottableX(0.0), plottableY(yhigh),
	                             plottableX(0.0), plottableY(ylow)));
  //devide y axi. there are three cases
  	  if(ylow<0 && yhigh<0)//ylow and yhigh are both -ve
  	  {
		  for(double i= 0.0; i>ylow; i-= DevideY)
		   g2d.draw(new Line2D.Double(plottableX(0.0)-2,plottableY(i),plottableX(0.0)+2,plottableY(i)));
		  for(double i= 0.0; i>ylow; i-= LabelY)
		  { g2d.draw(new Line2D.Double(plottableX(0.0)-5,plottableY(i),plottableX(0.0)+5,plottableY(i)));
		  	g2d.drawString(Double.toString(i), (float)plottableX(0)+7,(float)plottableY(i));
		  }
	  }
  	  else if(ylow>0 && yhigh>0)// both are +ve
  	  {
		  for(double i= 0.0; i<yhigh; i+= DevideY)
		   g2d.draw(new Line2D.Double(plottableX(0.0)-2,plottableY(i),plottableX(0.0)+2,plottableY(i)));
		  for(double i= 0.0; i<yhigh; i+= LabelY)
		  { g2d.draw(new Line2D.Double(plottableX(0.0)-5,plottableY(i),plottableX(0.0)+5,plottableY(i)));
		    g2d.drawString(Double.toString(i), (float)plottableX(0)+7,(float)plottableY(i));
		  }
	  }
  	  else // ylow is negative and yhigh is +ve
  	  {
		  for(double i= 0.0; i<yhigh ;i+=DevideY)
		   g2d.draw(new Line2D.Double(plottableX(0.0)-2,plottableY(i),plottableX(0.0)+2,plottableY(i)));
		  for(double i = 0; i<yhigh; i+=LabelY)
		  { g2d.draw(new Line2D.Double(plottableX(0.0)-5,plottableY(i),plottableX(0.0)+5,plottableY(i)));
		    g2d.drawString(Double.toString(i), (float)plottableX(0)+7,(float)plottableY(i));
		  }

		  for(double i= 0.0; i>ylow;i-=DevideY)
		   g2d.draw(new Line2D.Double(plottableX(0.0)-2,plottableY(i),plottableX(0.0)+2,plottableY(i)));
		  for(double i = 0; i>ylow; i-=LabelY)
		  { g2d.draw(new Line2D.Double(plottableX(0.0)-5,plottableY(i),plottableX(0.0)+5,plottableY(i)));
		    g2d.drawString(Double.toString(i), (float)plottableX(0)+7,(float)plottableY(i));
		  }
	  }
  //x-axis
	  g2d.draw(new Line2D.Double(plottableX(xlow), plottableY(0.0),
	                             plottableX(xhigh),plottableY(0.0)));
  //devide x axis there  are 3 cases
      if(xlow<0 && xhigh<0)//xlow and xhigh are both -ve
      {
		  for(double i= 0.0; i>xlow;i-=DevideX)
		   g2d.draw(new Line2D.Double(plottableX(i),plottableY(0.0)-2,plottableX(i),plottableY(0.0)+2));
		  for(double i = 0; i>xlow; i-=LabelX)
		  { g2d.draw(new Line2D.Double(plottableX(i),plottableY(0.0)-5,plottableX(i),plottableY(0.0)+5));
		  	g2d.drawString(Double.toString(i), (float)plottableX(i),(float)plottableY(0.0)+12);
		  }
	  }
      else if(xlow>0 && xhigh>0)//xlow  and xhigh are +ve
      {
		  for(double i= 0.0; i<xhigh; i+=DevideX)
		   g2d.draw(new Line2D.Double(plottableX(i),plottableY(0.0)-2,plottableX(i),plottableY(0.0)+2));
		  for(double i= 0.0; i<xhigh; i+=LabelX)
		  { g2d.draw(new Line2D.Double(plottableX(i),plottableY(0.0)-5,plottableX(i),plottableY(0.0)+5));
		    g2d.drawString(Double.toString(i), (float)plottableX(i),(float)plottableY(0.0)+12);
		  }


	  }
      else //xlow  is -ve and xhigh is +ve
      {
		  for(double i= 0.0; i<xhigh ;i+=DevideX)
		   g2d.draw(new Line2D.Double(plottableX(i),plottableY(0.0)-2,plottableX(i),plottableY(0.0)+2));
		  for(double i = 0; i<xhigh; i+=LabelX)
		   {
			 if(i==0){}//donothing.. don't draow 0.0..it is already drawn in y_axis
			 else{
			   g2d.draw(new Line2D.Double(plottableX(i),plottableY(0.0)-5,plottableX(i),plottableY(0.0)+5));
		       g2d.drawString(Double.toString(i), (float)plottableX(i),(float)plottableY(0.0)+12);
		       }
		   }

		  for(double i= 0.0; i>xlow;i-=DevideX)
		   g2d.draw(new Line2D.Double(plottableX(i),plottableY(0.0)-2,plottableX(i),plottableY(0.0)+2));
		  for(double i = 0; i>xlow; i-=LabelX)
		   {
			 if(i==0){}//donothing.. don't draow 0.0..it is already drawn in y_axis
			 else{
			   g2d.draw(new Line2D.Double(plottableX(i),plottableY(0.0)-5,plottableX(i),plottableY(0.0)+5));
		       g2d.drawString(Double.toString(i), (float)plottableX(i),(float)plottableY(0.0)+12);
		       }
		   }

	  }




  }

  private double evaluateExpression(double x)
  {
    Equation eq = new Equation(expression);
    double res = eq.Evaluate("x", x);
    return res;
  }
  private double evaluateSlopeY1(double x)
  {
	  DerivativeFinder df =new DerivativeFinder(expression);
	  Equation eq= new Equation(df.findDerivative(df.get_stringTokens()));
	  String s=new String("x");
	  return eq.Evaluate(s, x);
  }
  private double evaluateExpression2(double x)
  {
    Equation eq = new Equation(expression2);
    double res = eq.Evaluate("x", x);
    return res;
  }

  public void paintFunction(Graphics g)
  {
	Graphics2D g2d = (Graphics2D) g;
	g2d.setColor(Color.white);

	Point2D.Double start = new Point2D.Double(plottableX(xlow),plottableY(evaluateExpression(xlow)));


	for(double i=xlow; i<=xhigh; i+=0.01)
	{
		double x = plottableX(i);
		double y = plottableY(evaluateExpression(i));
		Point2D.Double end = new Point2D.Double(x,y);
		g2d.draw(new Line2D.Double(start, end));
		start = end;

	}
  }

  public void paintFunction2(Graphics g)
  {
	Graphics2D g2d = (Graphics2D) g;
	g2d.setColor(Color.red);

	Point2D.Double start = new Point2D.Double(plottableX(xlow),plottableY(evaluateExpression2(xlow)));


	for(double i=xlow; i<=xhigh; i+=0.01)
	{
		double x = plottableX(i);
		double y = plottableY(evaluateExpression2(i));
		Point2D.Double end = new Point2D.Double(x,y);
		g2d.draw(new Line2D.Double(start, end));
		start = end;

	}
  }

  public void paintY1SlopeLine(Graphics g)
  {
	  Graphics2D g2d = (Graphics2D) g;
	  g2d.setColor(Color.white);

	  double x2 = y1Slope_x;
	  double y2 = evaluateExpression(x2);
	  double slope = evaluateSlopeY1(x2);

	  double x1 = xlow;
	  double y1 = slope*(x1 - x2)+y2;

	  double x3 = xhigh;
	  double y3 = slope*(x3 - x2)+y2;

	  x1 =plottableX(x1); y1 = plottableY(y1);
	  x3 =plottableX(x3); y3 = plottableY(y3);

	  Point2D.Double start = new Point2D.Double(x1, y1);
	  Point2D.Double end = new Point2D.Double(x3, y3);
	  g2d.draw(new Line2D.Double(start, end));


  }
  public void paintY1SlopeCurve(Graphics g)
  {
	  Graphics2D g2d = (Graphics2D) g;
	  g2d.setColor(Color.yellow);

	  Point2D.Double start = new Point2D.Double(plottableX(xlow),plottableY(evaluateSlopeY1(xlow)));
	  for(double i=xlow+0.05; i<=xhigh; i+=0.05)
	  {
		  double x = plottableX(i);
		  double y = plottableY(evaluateSlopeY1(i));
		  Point2D.Double end = new Point2D.Double(x,y);
		  g2d.draw(new Line2D.Double(start, end));
		  start = end;
	  }
  }

  public void showIntegration(Graphics g)
  {
	  Graphics2D g2d = (Graphics2D) g;
	  g2d.setColor(Color.white);
	  for(double k=from; k<=to; k+=step)
	  {
		 double val1= evaluateExpression(k);
		 double val2= evaluateExpression(k+step);
		 double x1 = plottableX(k); double y1 = plottableY(0);
		 double x2 = plottableX(k); double y2 = plottableY(val1);
		 Point2D.Double start= new Point2D.Double(x1,y1);
		 Point2D.Double end  = new Point2D.Double(x2,y2);
		 g2d.draw(new Line2D.Double(start, end));//vertical at k
		 //now we draw thr line connecting thr vertival at k with the one at k+step
		 Point2D.Double end2= new Point2D.Double(plottableX(k+step),plottableY(val2));
		 g2d.draw(new Line2D.Double(end, end2));//vertical at k

	  }
  }

  public void paint(Graphics g) {

	Graphics2D g2d = (Graphics2D) g;//casting g to g2d
	Graphics2D g2d2 = (Graphics2D) g;//casting g to g2d
    Dimension d = this.getSize();
    g.setColor(Color.blue);
    g.fillRect(0, 0, d.width, d.height);

    paintAxes(g2d);
	if(functionDrawer==true)  paintFunction(g2d);
    if(function2Drawer==true)  paintFunction2(g2d2);
    if(y1Slope ==true)paintY1SlopeLine(g2d);
    if(y1SlopeCurve ==true)paintY1SlopeCurve(g2d);
    if(showInteg == true)showIntegration(g2d);

  }

  public Dimension getMinimumSize() {
    return new Dimension(50, 100);
  }

  public Dimension getPreferredSize() {
    return new Dimension(600, 400);
  }

  public Dimension getMaximumSize() {
    return new Dimension(200, 400);
  }

}
