import java.util.*;

public class MaxMinFinder
{
	private String expression; //the equation
	private String firstDerivative;
	private String secondDerivative;




	public MaxMinFinder(String str)
	{
		expression = str;

		DerivativeFinder df1 = new DerivativeFinder(expression);
		StringToVectorTokenizer stv1 = new StringToVectorTokenizer(expression);
		Vector<String> ve = stv1.tokenizeToVector();
		firstDerivative = df1.findDerivative(ve);

		DerivativeFinder df2 = new DerivativeFinder(expression);
		StringToVectorTokenizer stv2 = new StringToVectorTokenizer(firstDerivative);
		ve = stv2.tokenizeToVector();
		secondDerivative = df2.findDerivative(ve);
	}

    public String retExpression()
    {
		return expression;
	}
	public String ret1st()
	{
		return firstDerivative;
	}
	public String ret2nd()
	{
		return secondDerivative;
	}

    /*
      findMaxMin(..) where from and to are the boundary of the range through which
      the maxima and minima are to be found. step is the amount by which the function
      devides the region to find the roots, eps is the accuracy of finding the  roots
      **/
	public Vector<String> findMaxMin(double from, double to, double step, double eps )
	{

		RootFinder rf = new RootFinder(firstDerivative, eps);
		Vector<String> vec = rf.findAllRoots(from, to, step);
		return vec;

    }





	public static void main(String[ ] args)
	{
		Scanner sc = new Scanner(System.in);
		System.out.print("write down the Equation ");
	  	String equation =sc.nextLine();
	  	MaxMinFinder mf1 = new MaxMinFinder(equation);

	  	String firstd = mf1.ret1st();
	  	String secondd = mf1.ret2nd();

	  	Equation eq1 = new Equation(firstd);
	  	Equation eq2 = new Equation(secondd);

	  	Scanner sc2 = new Scanner(System.in);
		System.out.println("for x = ");
		String input =sc2.nextLine();
	    double value = Double.valueOf(input.trim()).doubleValue();

	    String x="x";
        System.out.println("\n 1st = " +eq1.Evaluate(x, value));
        System.out.println("\n 2nd = " +eq2.Evaluate(x, value));

        System.out.println("a = ");
        Scanner sc3 = new Scanner(System.in);
        String a =sc3.nextLine();
        System.out.println("b = ");
        Scanner sc4 = new Scanner(System.in);
        String b =sc4.nextLine();
        double from =Double.valueOf(a.trim()).doubleValue();
        double to = Double.valueOf(b.trim()).doubleValue();
        Vector<String> v= mf1.findMaxMin( from, to, 1, 0.0001 );
        for(int i=0; i<v.size();i++)
        System.out.print(v.get(i)+" ,");


	}//main
}